/****************************************************************************
 *	file_sel.c: ե
 *
 *			Date. 1994/09/06 --
 *				Programed by Nobuyuki Maruichi
 *				Adviced by S.Kouno
 *
 *	Note.
 *			Tab Size 4 / Shift Width = 4
 *	from
 *		ggxsnd (snd_file.c)
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Core.h>
#include <X11/Shell.h>

/*****************************************
 *	Atena Widget Υ󥯥롼ɡե
 *****************************************/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/AsciiSrc.h>
#include <X11/Xaw/AsciiSink.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#ifdef  X11R5
# include <X11/Xaw/Xawi18n.h>
# include <X11/Xaw/XawIm.h>
#endif  /*X11R5*/

/*******************************
 *	ѤΥإåե
 *******************************/
#include "file_sel.h"
#include "xfile.h"

Widget pFileShell, fileSelectorDialog;
Widget fileSelectorView, fileSelectorList;
Widget fileSelectorDir;

extern char *filePickup;
extern char *wildCard;
extern int (*sort_comp)(const void *file1, const void *file2);
void setPickup(Widget w, XtPointer client_data, XtPointer call_data);
void selectorPane(Widget w, XtPointer client_data, XtPointer call_data);
static void (*SelectFinish)(const char *dirName, const char *fileName);

void setSortFunc(Widget w, XtPointer client_data, XtPointer call_data);

FileSelctorInfo fileSelecterInfo;
static PopdownInfo filePopdownInfo;

/***************************************************************************
 *	menu_data ¤: ˥塼ܾ
 *	С
 *		type:			˥塼ܷ
 *		widgetName:		У̣٤ǤΤ߻ѡ̤
 *		myWidget:	
 *		function:		У̣٤ǤΤ߻ѡ̤
 *		
 *		̡widgetName        function  
 *		
 *		-- SmeBSB ---------------     ----    ˥塼ȥ롡
 *		
 *		 0 SmeLinefileMenuTopLine     ----    ڤΥ饤󡡡
 *		
 *		 1 SmeBSB allFile         selectorPaneե븡С
 *		
 *		 2 SmeBSB cdlFileOnfy     selectorPaneե롡
 *		
 *		 3 SmeBSB wrdFileOnly     selectorPaneƥȡե먭
 *		
 *		 4 SmeLinefileMenuLine        ----    ڤΥ饤󡡡
 *		
 *		 5 SmeBSB nonSort         selectorPaneȤʤ
 *		
 *		 6 SmeBSB asciiSort       selectorPaneȡ
 *		
 *		 7 SmeBSB suffixSort      selectorPaneեåȨ
 *		
 *		 8 SmeBSB dateSort        selectorPaneս祽ȡ
 *		
 *		 9 SmeBSB sizeSort        selectorPaneȡ
 *		
 *		10 SmeBSB       ----          ----    
 *		
 ***************************************************************************/
struct menu_data fileMenuInfo[] = {
	{TypeSmeLine, "fileMenuTopLine", NULL, NULL, NULL},
	{TypeSmeBSB,  "allFile",		 NULL, selectorPane, NULL}, 
	{TypeSmeBSB,  "logFileOnly",	 NULL, selectorPane, NULL}, 
	{TypeSmeBSB,  "nlogFileOnly",	 NULL, selectorPane, NULL}, 
	{TypeSmeBSB,  "txtFileOnly",	 NULL, selectorPane, NULL}, 
	{TypeSmeLine, "fileMenuLine",	 NULL, NULL, NULL},
	{TypeSmeBSB,  "nonSort",		 NULL, selectorPane, NULL},
	{TypeSmeBSB,  "asciiSort",		 NULL, selectorPane, NULL},
	{TypeSmeBSB,  "suffixSort",		 NULL, selectorPane, NULL},
	{TypeSmeBSB,  "dateSort",		 NULL, selectorPane, NULL},
	{TypeSmeBSB,  "sizeSort",		 NULL, selectorPane, NULL},
	{EOF, NULL, NULL, NULL, NULL}
};

/***************************************************************************
 *	ɤ߹ߥ˥塼fileMenus
 *		
 *		С̾ա̣
 *		
 *		 0menuButton˥塼ܥΥåȨmakeMenus() Ǻ
 *		
 *		 1menu      ˥塼ΥåȡmakeMenus() Ǻ
 *		
 *		 2menuName  ˥塼δ̾"fileMenu"
 *		
 *		 3num       ˥塼ܤο10
 *		
 *		 4popup     ݥåץåפǼ¹ԤؿNULLʤʤˡ
 *		
 *		 5popdown   ݥåץǼ¹ԤؿNULLʤʤˡ
 *		
 *		 6info      ˥塼ܾ󡡡fileMenuInfo
 *		
 ***************************************************************************/
struct menuData fileMenus = {
	NULL,
	NULL,
	"fileMenu", 
	sizeof(fileMenuInfo) / sizeof(fileMenuInfo[0]) - 1,
	NULL, 
	NULL, 
	fileMenuInfo
};

/***************************************************************************
 *	ɤ߹ߥ˥塼եܤؤݥfileSelectors
 *		
 *		ա̣
 *		
 *		 0ܣե븡С
 *		
 *		 1ܣãģ̥ե븡С
 *		
 *		 2ܣףңĥե븡С
 *		
 *		 3ܣԣɣƣƥե븡С
 *		
 *		 4      
 *		
 ***************************************************************************/
struct menu_data *fileSelectors[] = {
	&fileMenuInfo[1], &fileMenuInfo[2], 
	&fileMenuInfo[3], NULL
};

/***************************************************************************
 *	ɤ߹ߥ˥塼ե븡filePickupPaneInfo
 *		
 *		 ؿ ա̣
 *		
 *		 0setPickup ؿꨢե븡С
 *		
 *		 1setPickup ؿꨢãģ̥ե븡С
 *		
 *		 2setPickup ؿꨢףңĥե븡С
 *		
 *		EOF 
 *		
 ***************************************************************************/
selectorPanes filePickupPaneInfo[] = {
	{ 0, fileSelectors, &fileSelecterInfo, setPickup, NULL}, 
	{ 1, fileSelectors, &fileSelecterInfo, setPickup, "*.log"},
	{ 2, fileSelectors, &fileSelecterInfo, setPickup, "mes*.log"},
	{ 3, fileSelectors, &fileSelecterInfo, setPickup, "*.txt"},
	{ EOF, NULL, NULL, NULL, NULL}
};

/***************************************************************************
 *	ɤ߹ߥ˥塼ܤؤݥfileSortSelectors
 *		
 *		ա̣
 *		
 *		 0ܣ
 *		
 *		 1ܣ
 *		
 *		 2ܣ
 *		
 *		 3ܣ
 *		
 *		 4ܣ
 *		
 *		 5      
 *		
 ***************************************************************************/
struct menu_data *fileSortSelectors[] = {
	&fileMenuInfo[6], &fileMenuInfo[7], &fileMenuInfo[8],
	&fileMenuInfo[9], &fileMenuInfo[10], NULL
};

/***************************************************************************
 *	ɤ߹ߥ˥塼ե륽ȾfileSortPaneInfo
 *		
 *		ؿա̣
 *		
 *		 0setSortFunc 򨢥Ȥʤ
 *		
 *		 1setSortFunc ASCII ȡ
 *		
 *		 2setSortFunc Suffixȡ
 *		
 *		 3setSortFunc եȡ
 *		
 *		 4setSortFunc 򨢥ե륵ȡ
 *		
 *		EOF 
 *		
 ***************************************************************************/
selectorPanes fileSortPaneInfo[] = {
	{ 0, fileSortSelectors, &fileSelecterInfo, setSortFunc, NULL}, 
	{ 1, fileSortSelectors, &fileSelecterInfo, setSortFunc, ascii_comp}, 
	{ 2, fileSortSelectors, &fileSelecterInfo, setSortFunc, suffix_comp}, 
	{ 3, fileSortSelectors, &fileSelecterInfo, setSortFunc, date_comp}, 
	{ 4, fileSortSelectors, &fileSelecterInfo, setSortFunc, size_comp}, 
	{ EOF, NULL, NULL, NULL, NULL}
};

int (*compire_func)(const void *, const void *) = NULL;

/***************************************************************************
 *	fileSelector: ե롦쥯ƤӽФ
 *	
 *		void fileSelector(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void fileSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	extern char Filepath[];
	fSelectorMenuInfo *selectorInfo =  (fSelectorMenuInfo*)client_data;
	static selectorPanes *defPickup;
	static selectorPanes *defSort;
	/*extern Widget filenamewindow;*/
	void (*selectFinish)(const char *dirName, const char *fileName) = 
												selectorInfo->selectFinish;

	/*XtVaGetValues(filenamewindow, XtNstring, &filepath, NULL);*/
	dirName[0] = '\0';
	fileName[0] = '\0';
	defPickup = selectorInfo->filesPickupPane;
	defSort = selectorInfo->filesSortPane;
	fileCheck(Filepath, sizeof(dirName), dirName, sizeof(fileName), fileName);
	fileSelectorCall(w, dirName, defPickup, defSort, selectFinish);
}

/***************************************************************************
 *	isDirectory: 
 *	
 *		int isDirectory(const char *filename);
 *	
 *		const char *filename;
 *	֤
 *		FALSE:	
 *		TRUE:	
 *	
 *		
 ***************************************************************************/
int isDirectory(const char *filename)
{
	int status = False;
	struct stat sbuf;

	stat(filename, &sbuf);
	switch(sbuf.st_mode & S_IFMT) {
	case S_IFLNK:
	case S_IFDIR:
		status = True;
		break;
	case S_IFREG:
		break;
	}
	return(status);
}

/***************************************************************************
 *	fileNaming: ե̾Ƭ֤
 *	
 *		const char *fileNaming(const char *filename);
 *	
 *		const char *filename;
 *	֤
 *		ե̾Ƭ֤
 *	
 *		
 ***************************************************************************/
const char *fileNaming(const char *filename)
{
	int counter;

	counter = strlen(filename);
	while(counter > 0 && *(filename + counter - (counter > 0)) != '/')
		--counter;
	return(filename + counter);
}

/***************************************************************************
 *	fileCheck: ե̾Ƭ֤
 *	
 *		int fileCheck(const char *filepath, int dirLength, 
 *						char *dirName, int fileLength, char *fileName);
 *	
 *		const char *filepath;
 *		int dirLength;
 *		char *dirName;
 *		int fileLength;
 *		char *fileName;
 *	֤
 *		ե̾Ƭ֤
 *	
 *		
 ***************************************************************************/
int fileCheck(const char *filepath, int dirLength, char *dirName, int fileLength, char *fileName)
{
	int counter;
	int result;
	char *separate_ptr;
	char fnameBuffer[4096];

	counter = strlen(filepath);
	if(*(filepath + counter - (counter > 0)) == '/')
		--counter;
	if(counter >= sizeof(fnameBuffer))
		counter = sizeof(fnameBuffer) - 1;
	sprintf(fnameBuffer, "%.*s", counter, filepath);
	separate_ptr = fnameBuffer+counter;
	while(isDirectory(fnameBuffer) == FALSE && separate_ptr != NULL) {
		separate_ptr = strrchr(fnameBuffer, '/');
		if(separate_ptr != NULL) {
			*separate_ptr = '\0';
		}
	}
	result = (strlen(fnameBuffer) < dirLength);
	sprintf( dirName, "%.*s",  dirLength - 1, fnameBuffer);
	if(separate_ptr != NULL) {
		counter = separate_ptr - fnameBuffer + 1;
		sprintf(fileName, "%.*s", fileLength - 1, filepath + counter);
		result = (strlen(filepath + counter) < fileLength);
	}
	return(result);
}

/***************************************************************************
 *	multiPopupDialog: ѤΥΥݥåץå
 *	
 *		void multiPopupDialog(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void multiPopupDialog(Widget w, XtPointer client_data, XtPointer call_data)
{
	PopdownInfo *popdownData = (PopdownInfo*)client_data;
	Position x, y;
	Dimension width, height;

	/*********************************************************
	 *	ݥåץåפεˤʤääȤ礭
	 *********************************************************/
	XtVaGetValues(XtParent(popdownData->popupWidget), 
			XtNwidth, &width,
			XtNheight, &height,
			NULL);
	
	/***********************************
	 *	Root Window κɸϤѴ
	 ***********************************/
	XtTranslateCoords(XtParent(popdownData->popupWidget),	/* Widget */
			(Position) width/2,						/* x */
			(Position) height/2,					/* y */
			&x, &y);						/* coords on root window */

	/*******************************************************************
	 *	ݥåץåץΰ֤ꤹʤޤвƤʤ
	 *******************************************************************/
	XtVaSetValues(popdownData->popdownShell, 
			XtNx, x,
			XtNy, y,
			NULL);

	XtPopup(popdownData->popdownShell, XtGrabExclusive);
}

/***************************************************************************
 *	fileSelectorEnd: եλХåؿ
 *	
 *		void fileSelectorEnd(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void fileSelectorEnd(Widget w, XtPointer client_data, XtPointer call_data)
{
	String filename;
	PopdownInfo *popdownData = (PopdownInfo*)client_data;

	/*filename = XawDialogGetValueString((Widget)popdownData->client_data);*/
	XtVaGetValues((Widget)popdownData->client_data, XtNstring, &filename, NULL);
	if(SelectFinish != NULL)
		SelectFinish(fileSelecterInfo.searchingPath, filename);
}

/***************************************************************************
 *	DialogDone: ǥǡϿѤΥΥݥåץ
 *	
 *		void DialogDone(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void fileDialogDone(Widget w, XtPointer client_data, XtPointer call_data)
{
	String string;
	PopdownInfo *popdownData = (PopdownInfo*)client_data;

	XtPopdown(popdownData->popdownShell);
	XtSetSensitive(popdownData->popupWidget, TRUE);
	/*****************************************************
	 *	åȤϤʸ
	 *****************************************************/
	/*string = XawDialogGetValueString((Widget)popdownData->client_data);*/
	XtVaGetValues((Widget)popdownData->client_data, XtNstring, &string, NULL);
	/* printf("Dialog = \"%s\"\n", string); */
}

/***************************************************************************
 *	RecallAction: ؿrecall
 *	
 *		static void RecallAction(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				̤
 *		XEvent *event;			̤
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *	֤
 *		
 *	
 *		ꤵ줿åȤФơꤵ줿Ƥ֡
 *	Х
 *		Υϡ¿ǽǤ뤬¾ΥܥʤǤ뤿
 *		᥻ƥۡˤʤ꤫ͤʤ롣
 *		򻲾ȤƤΤФƤϡԤ̤ʤ
 *		Ȥ⤢롣
 ***************************************************************************/
/*ARGSUSED*/
static void RecallAction(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	Widget target = NULL;
	String *localParams = params;
	Cardinal localNumParams = *num_params;
	String actionString;
#ifdef ROOT_OF_RECALL
	extern Widget ROOT_OF_RECALL;
#endif /*ROOT_OF_RECALL*/
	
	switch((int)localNumParams) {
	default:	/* ΰ¿Ȥ */
#ifdef ROOT_OF_RECALL
		target = XtNameToWidget(ROOT_OF_RECALL, *localParams);
#else
		target = XtNameToWidget(pFileShell, *localParams);
#endif /*ROOT_OF_RECALL*/
#ifdef DEBUG
		if(target != NULL) {
			printf("recall target found....%#x\n", target);
		}
#endif /*DEBUG*/
		++localParams;
		--localNumParams;
		break;
	case 0:		/* ΰꤵƤʤȤ */
	case 1:
		XtWarning("Parameter Error: recall action table.");
		break;
	}
#ifdef DEBUG
	if((int)localNumParams > 0) {
		printf(">> \"%s()\" Action\n", *localParams);
	}
#endif /*DEBUG*/
	if(target != NULL) {
		actionString = *localParams;
		++localParams;
		--localNumParams;
		XtCallActionProc(target, actionString, 
							event, localParams, localNumParams);
	} else {
		printf("recall:target not found.\n");
	}
}

/***************************************************************************
 *	file_chd: 
 *	
 *		void file_chd(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void file_chd(Widget w, XtPointer client_data, XtPointer call_data)
{
	chdir(fileSelecterInfo.searchingPath);
}

/***************************************************************************
 *	paneMarkClaer: 쥯˥塼ܤΥޡ򥯥ꥢ
 *	
 *		void paneMarkClaer(struct menuData *menuInfo);
 *	
 *		struct menuData *menuInfo;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void paneMarkClaer(struct menuData *menuInfo)
{
	int i;
	int numOfMenuItems;

	numOfMenuItems = menuInfo->num;

	for (i = 0; i < numOfMenuItems; i++) {
		switch(menuInfo->info[i].type) {
		case TypeSmeBSB:
			XtVaSetValues(menuInfo->info[i].myWidget, 
											XtNleftBitmap, None, NULL);
			break;
		default:
			break;
		}
	}
}

/***************************************************************************
 *	paneTypeCount: 
 *	
 *		int paneTypeCount(const struct menu_data *menuInfo, int type);
 *	
 *		const struct menu_data *menuInfo;
 *		int type;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int paneTypeCount(const struct menu_data *menuInfo, int type)
{
	int counter;

	counter = 0;
	while((menuInfo + counter)->type == type)
		++counter;
	return(counter);
}

/***************************************************************************
 *	paneSequenceTypeCount: 
 *	
 *		int paneSequenceTypeCount(const struct menu_data *menuInfo, int type);
 *	
 *		const struct menu_data *menuInfo;
 *		int type;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int paneSequenceTypeCount(const struct menu_data *menuInfo, int type)
{
	int counter = 0;

	while(menuInfo->type != EOF) {
		while(menuInfo->type != type && menuInfo->type != EOF)
			++menuInfo;

		if(menuInfo->type == type) {
			while(menuInfo->type == type)
				++menuInfo;
			++counter;
		}
	}
	return(counter);
}

/***************************************************************************
 *	menuSelectorPanes: ˥塼ʬΥޡѹ
 *	
 *		void menuSelectorPanes(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void menuSelectorPanes(Widget w, XtPointer client_data, XtPointer call_data)
{
	int counter;
	selectorPanes *info = (selectorPanes*) client_data;
	extern Pixmap mark;

	if(info->option != NULL)
		info->option(w, client_data,  call_data);
	
	for(counter = 0;*(info->panesInfo + counter) != NULL;++counter) {
		if(counter == info->paneNo) {
			XtVaSetValues((*(info->panesInfo + counter))->myWidget, 
												XtNleftBitmap, mark, NULL);
		} else {
			XtVaSetValues((*(info->panesInfo + counter))->myWidget, 
												XtNleftBitmap, None, NULL);
		}
	}
	remakeFilePickup(info->fileSelecterInfo);
}

/***************************************************************************
 *	setPickup: ե򤷤ޤ
 *	
 *		void setPickup(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void setPickup(Widget w, XtPointer client_data, XtPointer call_data)
{
	selectorPanes *info = (selectorPanes*) client_data;

	if(info->client_data != NULL)
		filePickup = (char*)info->client_data;
	else
		filePickup = NULL;
}

/***************************************************************************
 *	setSortFunc: ե򤷤ޤ
 *	
 *		void setSortFunc(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void setSortFunc(Widget w, XtPointer client_data, XtPointer call_data)
{
	selectorPanes *info = (selectorPanes*) client_data;

	if(info->client_data != NULL)
		sort_comp = (int (*)(const void *, const void *))info->client_data;
	else
		sort_comp = NULL;
}

/***************************************************************************
 *	selectorPane: 򤵤줿˥塼ܤޡ
 *	
 *		void selectorPane(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void selectorPane(Widget w, XtPointer client_data, XtPointer call_data)
{
	struct menu_data *info = (struct menu_data*) client_data;
	extern Pixmap mark;

	XtVaSetValues(info->myWidget, XtNleftBitmap, mark, NULL);
}

/***************************************************************************
 *	MenuSelect: ˥塼
 *	
 *		static void MenuSelect(Widget w, 
 *								XtPointer client_data, XtPointer garbage);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	˥塼ֹ
 *		XtPointer garbage;		̤
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
static void MenuSelect(Widget w, XtPointer client_data, XtPointer garbage)
{
	struct menu_data *info = (struct menu_data*) client_data;

	/* printf("Menu item %s has been selected.\n", XtName(w)); */
	if (info->function != NULL) {
		info->function(w, client_data, NULL);
	}
}

/***************************************************************************
 *	makeMenus: ˥塼
 *	
 *		void makeMenus(Widget parent, struct menuData *menuInfo);
 *	
 *		Widget parent;		ƥå
 *		struct menuData *menuInfo;
 *	
 *		
 ***************************************************************************/
void makeMenus(Widget parent, struct menuData *menuInfo)
{
	int i;
	int numOfMenuItems;
	char name_buffer[20];
	Widget entry = NULL;

	numOfMenuItems = menuInfo->num;
	/* printf("Menu Items = %d.\n", numOfMenuItems); */

	sprintf(name_buffer, "%sButton", menuInfo->menuName);
	menuInfo->menuButton = XtVaCreateManagedWidget(
						name_buffer, 
						menuButtonWidgetClass, 
						parent,
						XtNmenuName, menuInfo->menuName, 
						NULL);
	menuInfo->menu = 
			XtCreatePopupShell(menuInfo->menuName, 
					simpleMenuWidgetClass, menuInfo->menuButton, NULL, 0);
	if(menuInfo->popup != NULL) {
		XtAddCallback(menuInfo->menu, XtNpopupCallback, 
							menuInfo->popup, (XtPointer)menuInfo);
	}
	if(menuInfo->popdown != NULL) {
		XtAddCallback(menuInfo->menu, XtNpopdownCallback, 
							menuInfo->popdown, (XtPointer)menuInfo);
	}

	for (i = 0; i < numOfMenuItems; i++) {
		switch(menuInfo->info[i].type) {
		case TypeSme:
			entry = XtCreateManagedWidget(menuInfo->info[i].widgetName, 
							smeObjectClass, menuInfo->menu, NULL, 0);
			break;
		case TypeSmeLine:
			entry = XtCreateManagedWidget(menuInfo->info[i].widgetName,
							smeLineObjectClass, menuInfo->menu, NULL, 0);
			break;
		case TypeSmeBSB:
			entry = XtCreateManagedWidget(menuInfo->info[i].widgetName, 
							smeBSBObjectClass, menuInfo->menu, NULL, 0);
			XtAddCallback(entry, XtNcallback, 
							MenuSelect, (XtPointer)&menuInfo->info[i]);
			break;
		default:
			break;
		}
		menuInfo->info[i].myWidget = entry;
	}
}

#ifdef	OPTION_DEBUG
/***************************************************************************
 *	: 
 *	
 *		void (Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void (Widget w, XtPointer client_data, XtPointer call_data)
{
}
#endif	/*OPTION_DEBUG*/

/***************************************************************************
 *	fileDialogInit: ǥǡϿѤΥޤॷ
 *	
 *		Widget fileDialogInit(XtAppContext app_context, Widget parent);
 *	
 *		XtAppContext app_context;
 *		Widget parent;				ƥå
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
Widget fileDialogInit(Widget parent)
{
	Widget fileSelectorDialogDone, fileSelectorCancel, fileSelectorFilename;
	Widget fileSelectorFilelabel, fileSelectorDirlabel;
	Widget fileSelectorArea, fileSelectorMenuArea;
#ifdef TEST_IMPREMENT
	static XtActionsRec fileSelectorActions[] = {
		{"recall", RecallAction}
	};
#endif /*TEST_IMPREMENT*/

	pFileShell = XtCreatePopupShell(
			"pFileShell",
			transientShellWidgetClass,
			parent,
			NULL,
			0
			);

	fileSelectorArea = XtVaCreateManagedWidget(
			"fileSelectorArea", 				/* arbitrary widget name */
			panedWidgetClass,		/* widget class from Form.h */
			pFileShell,	 			/* parent widget */
			NULL);					/* tarminate varargs list */

	fileSelectorMenuArea = XtVaCreateManagedWidget(
			"fileSelectorMenuArea", 			/* arbitrary widget name */
			boxWidgetClass,			/* widget class from Form.h */
			fileSelectorArea,	 			/* parent widget */
			NULL);					/* tarminate varargs list */

	makeMenus(fileSelectorMenuArea, &fileMenus);
	paneMarkClaer(&fileMenus);
	XtAddCallback((fileMenus.info+1)->myWidget, 
				XtNcallback, menuSelectorPanes, &filePickupPaneInfo[0]);
	XtAddCallback((fileMenus.info+2)->myWidget, 
				XtNcallback, menuSelectorPanes, &filePickupPaneInfo[1]);
	XtAddCallback((fileMenus.info+3)->myWidget, 
				XtNcallback, menuSelectorPanes, &filePickupPaneInfo[2]);
	XtAddCallback((fileMenus.info+4)->myWidget, 
				XtNcallback, menuSelectorPanes, &filePickupPaneInfo[3]);
	selectorPane((fileMenus.info+1)->myWidget, fileMenus.info+1, NULL);

	XtAddCallback((fileMenus.info+6)->myWidget, 
				XtNcallback, menuSelectorPanes, &fileSortPaneInfo[0]);
	XtAddCallback((fileMenus.info+7)->myWidget, 
				XtNcallback, menuSelectorPanes, &fileSortPaneInfo[1]);
	XtAddCallback((fileMenus.info+8)->myWidget, 
				XtNcallback, menuSelectorPanes, &fileSortPaneInfo[2]);
	XtAddCallback((fileMenus.info+9)->myWidget, 
				XtNcallback, menuSelectorPanes, &fileSortPaneInfo[3]);
	XtAddCallback((fileMenus.info+10)->myWidget, 
				XtNcallback, menuSelectorPanes, &fileSortPaneInfo[4]);
	selectorPane((fileMenus.info+7)->myWidget, fileMenus.info+7, NULL);

	fileSelectorDialog = XtCreateManagedWidget(
			"fileSelectorDialog", 				/* widget name   */
			formWidgetClass, 				/* widget class */
			fileSelectorArea, 					/* parent widget*/
			NULL,							/* argument list*/
			0 								/* arglist size */
			);

	fileSelectorFilelabel = XtVaCreateManagedWidget(
			"fileSelectorFilelabel", 			/* widget name   */
			labelWidgetClass, 				/* widget class */
			fileSelectorDialog, 					/* parent widget */
			XtNlabel, "File:",
			NULL 							/* argument list */
			);

	fileSelectorDirlabel = XtVaCreateManagedWidget(
			"fileSelectorDirlabel", 				/* widget name   */
			labelWidgetClass, 				/* widget class */
			fileSelectorDialog, 					/* parent widget */
			XtNlabel, "Dir: ",
			NULL 							/* argument list */
			);

	fileSelecterInfo.dirWidget = 
		XtVaCreateManagedWidget(
			"fileSelectorDir", 					/* widget name   */
			labelWidgetClass, 				/* widget class */
			fileSelectorDialog, 					/* parent widget */
			NULL 							/* argument list */
			);

	fileSelecterInfo.fileWidget = 
	fileSelectorFilename = XtVaCreateManagedWidget(
			"fileSelectorFilename", 				/* widget name   */
			asciiTextWidgetClass, 			/* widget class */
			fileSelectorDialog, 					/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype,	XawAsciiString,	
			NULL 							/* argument list */
			);

	fileSelectorView = XtVaCreateManagedWidget(
			"fileSelectorView", 					/* widget name   */
			viewportWidgetClass, 			/* widget class */
			fileSelectorDialog,	 				/* parent widget */
			XtNallowVert, TRUE, 			/*  */
			NULL 							/* argument list */
			);
	
	fileSelecterInfo.listWidget = 
		XtVaCreateManagedWidget(
			"fileSelectorList", 					/* widget name   */
			listWidgetClass, 				/* widget class */
			fileSelectorView, 					/* parent widget */
			NULL 							/* argument list */
			);

	fileSelectorDialogDone = XtCreateManagedWidget(
			"fileSelectorDialogDone", 			/* widget name   */
			commandWidgetClass, 			/* widget class */
			fileSelectorDialog, 					/* parent widget*/
			NULL, 							/* argument list*/
			0								/* arglist size */
			);

	fileSelectorCancel = XtCreateManagedWidget(
			"fileSelectorCancel", 				/* widget name   */
			commandWidgetClass, 			/* widget class */
			fileSelectorDialog, 					/* parent widget*/
			NULL, 							/* argument list*/
			0								/* arglist size */
			);

	fileSelecterInfo.searchingPath = getcwd(NULL, 0);
	/*remakeFileSelector(&fileSelecterInfo);*/
	/*filePopdownInfo.popupWidget  = popupButton;*/
	filePopdownInfo.popdownShell = pFileShell;
	filePopdownInfo.client_data  = (XtPointer)fileSelectorFilename;
	XtAddCallback(fileSelecterInfo.listWidget, XtNcallback, 
					 fileListSelect, &fileSelecterInfo);
	XtAddCallback(fileSelectorDialogDone, 
				XtNcallback, fileDialogDone, &filePopdownInfo);
	XtAddCallback(fileSelectorDialogDone, 
				XtNcallback, fileSelectorEnd, &filePopdownInfo);
	XtAddCallback(fileSelectorCancel, 
				XtNcallback, fileDialogDone, &filePopdownInfo);
	return(pFileShell);
}

/***************************************************************************
 *	fileSelectorCall: ǥǡϿѤΥޤॷ
 *	
 *		void fileSelectorCall(Widget popupButton, const char *dirName, 
 *			selectorPanes *selectorPane, selectorPanes *sortPane, 
 *			void (*selectFinish)(const char *dirName, const char *fileName));
 *	
 *		Widget popupButton;
 *		const char *dirName;
 *		selectorPanes *selectorPane;
 *		selectorPanes *sortPane;
 *		void (*selectFinish)(const char *dirName, const char *fileName);
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void fileSelectorCall(Widget popupButton, const char *dirName, 
			selectorPanes *selectorPane, selectorPanes *sortPane, 
			void (*selectFinish)(const char *dirName, const char *fileName))
{
	menuSelectorPanes(NULL, selectorPane, NULL);
	menuSelectorPanes(NULL, sortPane, NULL);
	chdir(dirName);
	fileSelecterInfo.searchingPath = getcwd(NULL, 0);
	remakeFileSelector(&fileSelecterInfo);
	filePopdownInfo.popupWidget  = popupButton;
	SelectFinish = selectFinish;
	multiPopupDialog(popupButton, &filePopdownInfo, NULL);
}

