/***************************************************************************
 *	luty.h: 
 *		
 *		Version 0.00 1997/08/07 -- 
 *		Version 1.00 1997/09/14 -- 
 *		
 *			Programmed by Nobuyuki Maruichi
 *	
 ***************************************************************************/

#ifndef _LUTY_H
#define _LUTY_H

/****************************************************************************
 *	MessageNode : ʬĥ꡼ʻȹ¤Ρʥå¤Ρ
 *	С
 *		const char *keyword;				
 *		const char *message;				ɤбå
 *		struct _messageNode *lowerLink;		ӤȤ˾ؤΥΡ
 *		struct _messageNode *higherLink;	ӤȤ礭ؤΥΡ
 *	
 *		󥯡ݥ󥿤ϡNULL ΤȤü򼨤
 *	
 *		MessageNode : ʬĥ꡼ʻȹ¤Τι¤
 *		
 *		ʬĥ꡼κ
 *		
 *		ɨȥʸ
 *		
 *		åȥåʸ
 *		
 *		بب
 *		
 *		
 *		
 *		
 *		ɨɨ
 *		
 *		åå
 *		
 *		بببب
 *		
 *		
 *		
 *		NULL
 *		ɨɨɨ
 *		
 *		ååå
 *		
 *		بببببب
 *		
 *		
 *		NULLNULLNULLNULLNULLNULL
 *		
 *		ʸӤʸӤ
 *		Ȥ¦Ȥ礭¦
 *		
 *		
 *		
 *	
 ***************************************************************************/
typedef struct _messageNode {
	const char *keyword;				/*  */
	const char *message;				/* ɤбå */
	struct _messageNode *lowerLink;		/* ӤȤ˾ؤΥΡ */
	struct _messageNode *higherLink;	/* ӤȤ礭ؤΥΡ */
} MessageNode;

MessageNode *makeMessages(MessageNode *topMess, const char *messages);
const MessageNode *messageSearch(const MessageNode *node, const char *keyword);

/****************************************************************************
 *	ʸåȼѤμ̻
 *		ISO_8859:	Latin-1(ASCII) ϰϤΥɡ0x210x7e
 *		JISX0201:	JIS X0201 ¯ȾѲ̾ϰϤΥɡ0xa10xdf
 *		JISX0208:	JIS X0208-1983/1990 JISϰϤΥ
 *		JISX0212:	JIS X0212-1990 JISϰϤΥ
 *		OUTOFRANGE:	ʸϰϳΥ
 ***************************************************************************/
#define	ISO_8859	0
#define JISX0201	1
#define JISX0208	2
#define JISX0212	3
#define OUTOFRANGE	4

/****************************************************************************
 *	EUC Υɥåؤʸ
 *		SS2:	single shift 2) ɥåȣؤղä륳
 *		SS3:	(Single shift 3) ɥåȣؤղä륳
 ***************************************************************************/
#define	SS2	(0x8e)
#define	SS3	(0x8f)

/****************************************************************************
 *	CodesetInfo
 *	
 *	
 *	
 ***************************************************************************/
typedef struct {
	int (*codeset)(unsigned const char *string_ptr);
	int (*string2jis)(unsigned const char *string_ptr, int old, int new);
	int (*encode)(int code, int old, int new);
} CodesetInfo;

/****************************************************************************
 *	CodeSetsCheckɼȽѹ¤
 *	Сѿؿ
 *		checkChar():	ɼŬåؿ
 *						ʸΥɼ̡JIS/EUC/SJISΤʤɡˤȲ
 *						ꤷơȤƴޤޤʸȰ۾ʸ
 *						ȽꡦϿޤ
 *		status:			ɼ̥åؿǻʸ¸ߤ
 *						ʸʲΥӥåȥޥؤ줿Τ
 *						Ͽޤ
 *		
 *		     4        3       2       1       0   
 *		
 *		   ̻   OUTOFRANGEJISX0212JISX0208JISX0201ISO_8859
 *		
 *		ӥåȥޥ  0x0010   0x0008  0x0004  0x0002  0x0001 
 *		
 *						ʸϰϳΥɡOUTOFRANGEˤޤޤƤ
 *						ϡǽȤƤ꼫ΤȤ
 *						ꡣꤷƤηϤǤʤȽꤵ롣
 *		type:			߰֡ʤ⤷ľˤʸ
 *						ISO_8859/JISX0201/JISX0208/JISX0212 Τ줫
 *		src_ptr:		åƤʸƬʾ˹
 *		
 ***************************************************************************/
typedef struct {
	unsigned const char *(*checkChar)(unsigned const char *, int *, int *);
	int status;
	int type;
	int detectAt;
	unsigned const char *src_ptr;
} CodeSetsCheck;

/****************************************************************************
 *	CodesetProc : ʸ󤫤ʸȥɤμؿ
 *	
 *	
 *		typedef int (*CodesetProc)(
 *						unsigned const char **src_ptr, int old, int *type);
 *	
 *		unsigned const char **src_ptr;	ʸ
 *		int old;		ľʸʸʸåȼѤμ̻ҡ
 *						ISO_8859/JISX0201/JISX0208/JISX0212 Τ줫
 *		int *type;		ƬʸʸʸåȼѤμ̻ҡˤ֤
 *						ISO_8859/JISX0201/JISX0208/JISX0212 Τ줫
 *	֤
 *		Ƭʸʸ
 *		ISO 8859  ξ:	0x000x7f
 *		JIS X0201 ξ:	0xa00xff
 *		JIS X0208 ξ:	0x21210x7f7f
 *		JIS X0212 ξ:	0x21210x7f7f
 *	
 *		ʸ󤫤Ƭʸʸ򡢤ʸμ̡ISO8859(ASCII)/
 *		JIS X0201ȾѤʡ/JIS X0208JIS/JIS X0212JISˡ
 *		ξȶ˼Фޤ
 *	η˳ؿ
 *		codesetJis:   JIS ʸ󤫤Ƭʸʸȥɤؿ
 *		codesetEuc:   EUC ʸ󤫤Ƭʸʸȥɤؿ
 *		codesetSjis:  SJISʸ󤫤Ƭʸʸȥɤؿ
 *	Ȼ
 *		ʸåȼѤμ̻ҡluty.h
 *		
 *		
 ***************************************************************************/
typedef int (*CodesetProc)(unsigned const char **src_ptr, int old, int *type); 

int codesetJis(unsigned const char **src_ptr, int old, int *type);
int codesetEuc(unsigned const char **src_ptr, int old, int *type);
int codesetSjis(unsigned const char **src_ptr, int old, int *type);

/****************************************************************************
 *	EncodeProc : ʸȥɤѴʸؿ
 *	
 ***************************************************************************/
typedef int (*EncodeProc)(unsigned char *dest_ptr, int code, int old, int type);

/****************************************************************************
 *	JaLocales 󷿡ܤ Locale ̤
 *	
 *		NoJapanese:	ܸǤʤ
 *		JaJIS:		JIS ɡJIS X0202-1991
 *		JaEUC:		ܸ EUC
 *		JaSJIS:		եJISɡMS
 *		
 ***************************************************************************/
enum JaLocales {NoJapanese = EOF, JaJIS = 0, JaEUC, JaSJIS};

MessageNode *makeMessages(MessageNode *topMess, const char *messages);
const MessageNode *messageSearch(const MessageNode *node, const char *keyword);

int encodeJis1(unsigned char *dest, int code, int old, int type);
int encodeJis2(unsigned char *dest, int code, int old, int type);
int encodeEuc(unsigned char *dest, int code, int old, int type);
int encodeSjis(unsigned char *dest, int code, int old, int type);

int string2otherCodeset(char *destTop, size_t length, const char *srcTop, 
		int (*codeset)(unsigned const char **src_ptr, int old, int *type), 
		int (*encode)(unsigned char *dest_ptr, int code, int old, int type));

int checkEncode(const void *stringInfo, 
			unsigned const char *(*stringOut)(const void *stringInfo), 
						const void *(*nextString)(const void *stringInfo));

char *string2otherEncodeNewString(const char *src, 
		int (*codeset)(unsigned const char **src_ptr, int old, int *type), 
		int (*encode)(unsigned char *dest_ptr, int code, int old, int type));
/*
char **string2otherEncodeNewStrArray(const char **src_ptr, 
		int (*codeset)(unsigned const char **src_ptr, int old, int *type), 
		int (*encode)(unsigned char *dest_ptr, int code, int old, int type));
 */
char **strArray2cnvNewStrArray(const char **src_ptr, 
		int (*codeset)(unsigned const char **src_ptr, int old, int *type), 
		int (*encode)(unsigned char *dest_ptr, int code, int old, int type));

unsigned const char *arrayStringOut(const void *stringInfo);
const void *arrayNextString(const void *stringInfo);
unsigned const char *lineLinkStringOut(const void *stringInfo);
const void *lineLinkNextString(const void *stringInfo);

const char *keyword2mes(const char *keyword);

#endif /*_LUTY_H*/

