/****************************************************************************
 *	xnmess.h: 
 *	
 *			Version 0.4.0	1998/09/21 -- 1998/10/13 
 *					Date.	1999/01/27 -- 
 *				Programed by Nobuyuki Maruichi
 *
 *	Note.
 *			EUC Kanji Code / JIS X0208-1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

#ifndef	_NYAN_E2_BROWSER
#define	_NYAN_E2_BROWSER

/*************************************
 *	X Toolkit Υ󥯥롼ɥե
 *************************************/
#include <X11/Intrinsic.h>		/* Intrinsics Definitions */
#include <X11/StringDefs.h>		/* Standard Name-String definitions */
#include "stringuty.h"

/***************************************************************************
 --------------------------------------------------------------------------
	ץꥱ󡦥꥽
 --------------------------------------------------------------------------
 Name               Class              RepType         Default Value
 ----               -----              -------         -------------
 logFile            LogFile            String          NULL
 markString         MarkString         String          
											"mk0: \nmk1:|\nmk2:+\nmk3:+"
 messages           Messages           String          NULL
 help               Help               Boolean         FALSE
 treeMode           TreeMode           Boolean         FALSE
 verticalMargin     VerticalMargin     Int             28
 jencoding          Jencoding          String          ENCODING_DIR
 treeUsable         TreeUsable         Boolean         TRUE
 moveNewWindow      MoveNewWindow      Boolean         FALSE
 regexMessTop       RegexMessTop       String          
				"^[0-9][0-9][0-9][0-9][0-9]/[0-9][0-9][0-9][0-9][0-9] "
 regexMode          RegexMode          Boolean         False

	logFile :		ե̾ꤷƥץ󤹤뤿˻Ѥ
	markString:		ĥ꡼¤ɽ뤿ʸϿ
	messages:		å
	help:			إɽԤɤꤹե饰-h, --help ѡ
	treeMode: 		ĥ꡼⡼ɤ򼨤ե饰-t, --tree or -n, --number
	verticalMargin:	ӥ塼ΥǥեȤοľιԿ
	jencoding:		ܤΥбܸ쥨󥳡ɼ̤ξ
	treeUsable:		̤
	moveNewWindow:	ȯȤΤȤɥե饰
	regexMessTop:	ȯƬȽѤɽʸregexModeͭΤߡ
	regexMode:		ɽˤȯФԤɤ򼨤ե饰

 ***************************************************************************/

/***************************************************************************
 *	MessTree ȯĥ꡼¤
 *	Сѿ
 *		number:			ȯֹ
 *		parent_ptr:		ȯĥ꡼ǿƤؤݥ
 *		child_ptr:		ȯĥ꡼ǻҤؤݥ
 *		prev_ptr:		ȯĥ꡼ǷƱƤľˤؤݥ
 *		next_ptr:		ȯĥ꡼ƱƤľˤؤݥ
 *	ǡ¤
 *		ȯĥ꡼κܨȯ
 *		
 *		 number  number 
 *		
 *		 messageʸ󨭡 messageʸ
 *		
 *		 treeWidget  treeWidget 
 *		
 *		 parent_ptr  NULL  parent_ptr 
 *		
 *		 child_ptr child_ptr   NULL 
 *		
 *		prev_ptr NULL prev_ptr NULL 
 *		
 *		next_ptr NULL next_ptr
 *		
 *		
 *		
 *		ȯ
 *		
 *		 number 
 *		
 *		 messageʸ
 *		
 *		 treeWidget 
 *		
 *		 parent_ptr 
 *		
 *		 child_ptr   NULL 
 *		
 *		prev_ptr
 *		
 *		next_ptr NULL 
 *		
 *		
 *	
 ***************************************************************************/
typedef struct _MessTree {
	int number;
	LineLink *message;
	Widget treeWidget;
	struct _MessTree *parent_ptr;
	struct _MessTree *child_ptr;
	struct _MessTree *prev_ptr;
	struct _MessTree *next_ptr;
} MessTree;

/***************************************************************************
 *	MessTitlesInfo ȯĥ꡼¤
 *	Сѿ
 *		LineLink **messages;	ȯƤʸؤʻȹ¤
 *		char **titles;			ȯȥꥹȡNULLüʸ
 *		int num;				ȯ
 *		int counter;			ĥ꡼
 *		char *(*strproc)(char *string);		ʸؿѴؿ
 *		LineLink *(*messagePickup)(int number, const struct _MessTitlesInfo *info);
 *	ǡ¤
 *		ȥꥹȾ󨬨ȯ
 *		LineLink* 
 *		message 
 *		ȥʸ󨡨
 *		titles char*󨭡
 *		
 *		 numȯ
 *		
 *		 counterNULL
 *		
 *		 (*strproc)() 
 *		NULL
 *		(*messagePickup)()
 *		
 *		
 *		
 *		Сѿ titles NULL ʤǡϡ̵ˤ롣
 *		
 ***************************************************************************/
typedef struct _MessTitlesInfo {
	LineLink **messages;	/* ȯƤʸؤʻȹ¤ */
	char **titles;			/* ȯȥꥹȡNULLüʸ */
	int num;				/* ȯ */
	int counter;			/* ĥ꡼ */
	char *(*strproc)(char *string);		/* ʸؿѴؿ */
	LineLink *(*messagePickup)(int number, const struct _MessTitlesInfo *info);
} MessTitlesInfo;

typedef struct _CurrentMessageInfo {
	int id;
	MessTitlesInfo *list;
	Widget logTitle;
	Widget logText;
	Widget logEditor;
	Widget logPrev;
	Widget logNext;
} CurrentMessageInfo;

/*****************************************************
 *	ץꥱ󡦥꥽Υ꥽̾饹̾
 *****************************************************/
#define XtNlogFile			"logFile"
#define XtCLogFile			"LogFile"
#define XtNhelp				"help"
#define XtCHelp				"Help"
#define XtNsstdin			"sstdin"
#define XtCSstdin			"Sstdin"
#define XtNtreeMode			"treeMode"
#define XtCTreeMode			"TreeMode"
#define XtNmessages			"messages"
#define XtCMessages			"Messages"
#define XtNverticalMargin	"verticalMargin"
#define XtCVerticalMargin	"VerticalMargin"
#define	XtNjencoding		"jencoding"
#define	XtCJencoding		"Jencoding"
#define XtNmarkString		"markString"
#define XtCMarkString		"MarkString"
#define XtNtreeUsable		"treeUsable"
#define XtCTreeUsable		"TreeUsable"
#define XtNmoveNewWindow	"moveNewWindow"
#define XtCMoveNewWindow	"MoveNewWindow"
#define XtNregexMessTop		"regexMessTop"
#define XtCRegexMessTop		"RegexMessTop"
#define XtNregexMode		"regexMode"
#define XtCRegexMode		"RegexMode"

#define ENCODING_DIR		"ja:ja_JP.eucJP\n\
	ja_JP:ja_JP.eucJP\n\
	ja_JP.ujis:ja_JP.eucJP\n\
	ja_JP.eucJP:ja_JP.eucJP\n\
	Jp_JP:ja_JP.eucJP\n\
	ja_JP.AJEC:ja_JP.eucJP\n\
	ja_JP.EUC:ja_JP.eucJP\n\
	ja_JP.ISO-2022-JP:ja_JP.JIS7\n\
	ja_JP.JIS:ja_JP.JIS7\n\
	ja_JP.jis7:ja_JP.JIS7\n\
	ja_JP.mscode:ja_JP.SJIS\n\
	ja_JP.SJIS:ja_JP.SJIS\n\
	japanese:ja_JP.eucJP\n\
	japan:ja_JP.eucJP\n\
	Japanese-EUC:ja_JP.eucJP"

/*****************************************************
 *	ץꥱ󡦥꥽Υ꥽̾饹̾
 *****************************************************/
typedef struct {
	String file;
	String messages;
	String markString;
	Boolean help;
	Boolean sstdin;
	Boolean treeMode;
	String jencoding;
	Dimension verticalMargin;
	Boolean treeUsable;
	Boolean moveNewWindow;
	String regexMessTop;
	Boolean regexMode;
} AppData, *AppDataPtr;

/*****************************************************
 *	Xnmess Version
 *****************************************************/
#define XNMESS_VERSION "0.5.1"

/***************************************************************************
 *	ץȥס
 ***************************************************************************/
extern Widget topLevel;

void PopdownAncestorShell(Widget w, XtPointer client_data, XtPointer call_data);
const char *keyword2mes(const char *keyword);

#endif	/*_NYAN_E2_BROWSER*/

